/*
 * Copyright 2014 (c) Anna Schumaker.
 */
#include <core/audio.h>
#include <core/core.h>
#include <core/idle.h>
#include <core/playlist.h>
#include <core/settings.h>
#include <core/tags/tags.h>


static bool core_defragment(void *data)
{
	if (tags_defragment()) {
		playlist_save();
		audio_save();
	}
	return true;
}

void core_init(int *argc, char ***argv, struct core_init_data *init)
{
	idle_init(init->idle_sync);
	settings_init();
	tags_init();
	playlist_init(init->playlist_cb);
	audio_init(argc, argv, init->audio_ops);

	idle_schedule(IDLE_SYNC, core_defragment, NULL);
}

void core_deinit()
{
	audio_deinit();
	playlist_deinit();
	tags_deinit();
	settings_deinit();
	idle_deinit();
}
